Index: trunk/src/world_entities/test_entity.cc
===================================================================
--- trunk/src/world_entities/test_entity.cc	(revision 9656)
+++ trunk/src/world_entities/test_entity.cc	(revision 9869)
@@ -26,5 +26,5 @@
 
 #include "test_entity.h"
-
+#include "debug.h"
 
 #include "interactive_model.h"
@@ -35,14 +35,14 @@
 
 
-
-CREATE_FACTORY(TestEntity, CL_TEST_ENTITY);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinition(TestEntity);
+CREATE_FACTORY(TestEntity);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(TestEntity, CL_TEST_ENTITY,
-                            addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
-                            ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
-                            ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
-                            ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
-                            
+CREATE_SCRIPTABLE_CLASS(TestEntity,
+                        addMethod("setAbsCoor", Executor3<PNode, lua_State*,float,float,float>(&PNode::setAbsCoor))
+                        ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
+                        ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
+                        ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
                        );
 
@@ -75,5 +75,5 @@
 void TestEntity::init()
 {
-  this->setClassID(CL_TEST_ENTITY, "TestEntity");
+  this->registerObject(this, TestEntity::_objectList);
   this->toList(OM_GROUP_00);
 
@@ -91,6 +91,6 @@
 
   LoadParam(root, "md2animation", this, TestEntity, setAnim)
-      .describe("sets the animation of the md2 model")
-      .defaultValues(1);
+  .describe("sets the animation of the md2 model")
+  .defaultValues(1);
 
 }
Index: trunk/src/world_entities/test_entity.h
===================================================================
--- trunk/src/world_entities/test_entity.h	(revision 9656)
+++ trunk/src/world_entities/test_entity.h	(revision 9869)
@@ -15,4 +15,5 @@
 class TestEntity : public WorldEntity, public PhysicsInterface
 {
+  ObjectListDeclaration(TestEntity);
  public:
   TestEntity ();
Index: trunk/src/world_entities/weapons/aim.cc
===================================================================
--- trunk/src/world_entities/weapons/aim.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/aim.cc	(revision 9869)
@@ -29,4 +29,5 @@
 
 
+ObjectListDefinition(Aim);
 
 /**
@@ -50,6 +51,6 @@
 Aim::~Aim ()
 {
-/*  if (this->text != NULL)
-    delete this->text;*/
+  /*  if (this->text != NULL)
+      delete this->text;*/
 }
 
@@ -59,5 +60,5 @@
 void Aim::init()
 {
-  this->setClassID(CL_CROSSHAIR, "Aim");
+  this->registerObject(this, Aim::_objectList);
   this->setName("Aim");
 
@@ -79,10 +80,10 @@
 
 
-/*  this->text = new Text();
-  this->text->setLayer(this->getLayer());
-  this->text->setParent2D(this);
-  this->text->setRelCoor2D(10, -50);
-  this->text->setParentMode2D(E2D_PARENT_MOVEMENT);
-  this->text->setText("Testing");*/
+  /*  this->text = new Text();
+    this->text->setLayer(this->getLayer());
+    this->text->setParent2D(this);
+    this->text->setRelCoor2D(10, -50);
+    this->text->setParentMode2D(E2D_PARENT_MOVEMENT);
+    this->text->setText("Testing");*/
 }
 
@@ -92,11 +93,11 @@
 
   LoadParam(root, "texture", this, Aim, setTexture)
-      .describe("the texture-file to load onto the Aim");
+  .describe("the texture-file to load onto the Aim");
 
   LoadParam(root, "size", this, Aim, setSize)
-      .describe("the size of the Aim in Pixels");
+  .describe("the size of the Aim in Pixels");
 
   LoadParam(root, "rotation-speed", this, Aim, setRotationSpeed)
-      .describe("the Speed with which the Aim should rotate");
+  .describe("the Speed with which the Aim should rotate");
 
   LoadParam(root, "target-group", this, Aim, setTargetGroupS);
@@ -107,6 +108,6 @@
   ObjectManager::EntityList::iterator entity;
   //printf("%d\n", this->targetGroup);
-  for (entity = State::getObjectManager()->getObjectList(this->targetGroup).begin();
-       entity != State::getObjectManager()->getObjectList(this->targetGroup).end();
+  for (entity = State::getObjectManager()->getEntityList(this->targetGroup).begin();
+       entity != State::getObjectManager()->getEntityList(this->targetGroup).end();
        entity ++)
   {
@@ -117,5 +118,5 @@
       //if (this->getParent() != (*entity))
       {
-        printf("found target::: %d %s::%s\n", (*entity)->getOMListNumber(), (*entity)->getClassCName(), (*entity)->getCName());
+        //        printf("found target::: %d %s::%s\n", (*entity)->getOMListNumber(), (*entity)->getClassCName(), (*entity)->getCName());
         this->anim->replay();
         this->setParentSoft(*entity, 5);
@@ -125,6 +126,6 @@
   }
 
-   //if no target found:
-   this->setParent(PNode::getNullParent());
+  //if no target found:
+  this->setParent(PNode::getNullParent());
 }
 
@@ -165,42 +166,42 @@
   this->shiftDir2D(dt * rotationSpeed);
 
-//   char outputText[100];
-//   sprintf(outputText, "%s - distance: %f\n", this->getParent()->getName(), (this->source->getAbsCoor() - this->getAbsCoor()).len());
-//   this->text->setText(outputText);
-
-
-//  if (this->source->getAbsCoor().x > this->getAbsCoor().x )
+  //   char outputText[100];
+  //   sprintf(outputText, "%s - distance: %f\n", this->getParent()->getName(), (this->source->getAbsCoor() - this->getAbsCoor()).len());
+  //   this->text->setText(outputText);
+
+
+  //  if (this->source->getAbsCoor().x > this->getAbsCoor().x )
   diffVec = ( this->getAbsCoor() - this->source->getAbsCoor() );
-//only look for target if the aim hasn`t locked a target yet or if the actual target is out of range
-   if(this->getParent() == PNode::getNullParent() ||
+  //only look for target if the aim hasn`t locked a target yet or if the actual target is out of range
+  if(this->getParent() == PNode::getNullParent() ||
       diffVec.len() > range )// ||
-     //( acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) > angle))
-    {
-     this->setParentSoft(PNode::getNullParent(),5);
-     this->searchTarget();
-    }
-
-//   float z = 0.0f;
-//   glReadPixels ((int)this->getAbsCoor2D().x,
-//                  GraphicsEngine::getInstance()->getResolutionY()-(int)this->getAbsCoor2D().y-1,
-//                  1,
-//                  1,
-//                  GL_DEPTH_COMPONENT,
-//                  GL_FLOAT,
-//                  &z);
-//
-//
-//   GLdouble objX=.0, objY=.0, objZ=.0;
-//   gluUnProject(this->getAbsCoor2D().x,
-//                GraphicsEngine::getInstance()->getResolutionY()-this->getAbsCoor2D().y-1,
-//                .99,  // z
-//                GraphicsEngine::modMat,
-//                GraphicsEngine::projMat,
-//                GraphicsEngine::viewPort,
-//                &objX,
-//                &objY,
-//                &objZ );
-//aa
-//   this->setAbsCoor(objX, objY, objZ);
+    //( acos( (this->source->getAbsDirX()).dot(diffVec)/(diffVec.len() * (this->source->getAbsDirX()).len() ) ) > angle))
+  {
+    this->setParentSoft(PNode::getNullParent(),5);
+    this->searchTarget();
+  }
+
+  //   float z = 0.0f;
+  //   glReadPixels ((int)this->getAbsCoor2D().x,
+  //                  GraphicsEngine::getInstance()->getResolutionY()-(int)this->getAbsCoor2D().y-1,
+  //                  1,
+  //                  1,
+  //                  GL_DEPTH_COMPONENT,
+  //                  GL_FLOAT,
+  //                  &z);
+  //
+  //
+  //   GLdouble objX=.0, objY=.0, objZ=.0;
+  //   gluUnProject(this->getAbsCoor2D().x,
+  //                GraphicsEngine::getInstance()->getResolutionY()-this->getAbsCoor2D().y-1,
+  //                .99,  // z
+  //                GraphicsEngine::modMat,
+  //                GraphicsEngine::projMat,
+  //                GraphicsEngine::viewPort,
+  //                &objX,
+  //                &objY,
+  //                &objZ );
+  //aa
+  //   this->setAbsCoor(objX, objY, objZ);
 }
 
@@ -211,22 +212,22 @@
 {
 
- if( this->getParent() != PNode::getNullParent() )
+  if( this->getParent() != PNode::getNullParent() )
   {
-  glPushMatrix();
-  glTranslatef(this->getAbsCoor2D().x, this->getAbsCoor2D().y, 0);
-
-  glRotatef(this->getAbsDir2D(), 0,0,1);
-  this->material.select();
-  glBegin(GL_TRIANGLE_STRIP);
-  glTexCoord2f(0, 0);
-  glVertex2f(-this->getSizeX2D(), -this->getSizeY2D());
-  glTexCoord2f(1, 0);
-  glVertex2f(this->getSizeX2D(), -this->getSizeY2D());
-  glTexCoord2f(0, 1);
-  glVertex2f(-this->getSizeX2D(), this->getSizeY2D());
-  glTexCoord2f(1, 1);
-  glVertex2f(this->getSizeX2D(), this->getSizeY2D());
-  glEnd();
-  glPopMatrix();
+    glPushMatrix();
+    glTranslatef(this->getAbsCoor2D().x, this->getAbsCoor2D().y, 0);
+
+    glRotatef(this->getAbsDir2D(), 0,0,1);
+    this->material.select();
+    glBegin(GL_TRIANGLE_STRIP);
+    glTexCoord2f(0, 0);
+    glVertex2f(-this->getSizeX2D(), -this->getSizeY2D());
+    glTexCoord2f(1, 0);
+    glVertex2f(this->getSizeX2D(), -this->getSizeY2D());
+    glTexCoord2f(0, 1);
+    glVertex2f(-this->getSizeX2D(), this->getSizeY2D());
+    glTexCoord2f(1, 1);
+    glVertex2f(this->getSizeX2D(), this->getSizeY2D());
+    glEnd();
+    glPopMatrix();
   }
 
Index: trunk/src/world_entities/weapons/aim.h
===================================================================
--- trunk/src/world_entities/weapons/aim.h	(revision 9656)
+++ trunk/src/world_entities/weapons/aim.h	(revision 9869)
@@ -19,4 +19,5 @@
 template<class T> class tAnimation;
 
+
 //! An Aim for zooming in on Targets.
 /**
@@ -28,4 +29,5 @@
 class Aim : public PNode, public Element2D
 {
+  ObjectListDeclaration(Aim);
 
 public:
Index: trunk/src/world_entities/weapons/aiming_system.cc
===================================================================
--- trunk/src/world_entities/weapons/aiming_system.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/aiming_system.cc	(revision 9869)
@@ -21,13 +21,12 @@
 
 #include "state.h"
+#include "debug.h"
 
 #include "aabb.h"
 #include "obb_tree.h"
 
-#include <vector>
 
 
-
-
+ObjectListDefinition(AimingSystem);
 
 /**
@@ -55,5 +54,5 @@
 void AimingSystem::init()
 {
-  this->setClassID(CL_AIMING_SYSTEM, "AimingSystem");
+  this->registerObject(this, AimingSystem::_objectList);
   this->setName("AimingSystem");
 
@@ -63,5 +62,5 @@
   // registering default reactions:
   this->unsubscribeReaction(CREngine::CR_OBJECT_DAMAGE);
-  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, CL_WORLD_ENTITY);
+  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, WorldEntity::staticClassID());
 
   this->range = 1000.0f;
Index: trunk/src/world_entities/weapons/aiming_system.h
===================================================================
--- trunk/src/world_entities/weapons/aiming_system.h	(revision 9656)
+++ trunk/src/world_entities/weapons/aiming_system.h	(revision 9869)
@@ -21,4 +21,5 @@
 class AimingSystem : public WorldEntity
 {
+  ObjectListDeclaration(AimingSystem);
 
  public:
Index: trunk/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/aiming_turret.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/aiming_turret.cc	(revision 9869)
@@ -27,6 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(AimingTurret, CL_AIMING_TURRET);
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(AimingTurret, CL_AIMING_TURRET);
+CREATE_FACTORY(AimingTurret);
 
 
@@ -64,5 +65,5 @@
 void AimingTurret::init()
 {
-  this->setClassID(CL_AIMING_TURRET, "AimingTurret");
+  this->registerObject(this, AimingTurret::_objectList);
 
   Animation3D* animation1 = this->getAnimation(WS_ACTIVATING, this);
@@ -86,5 +87,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_GUIDED_MISSILE);
+  this->setProjectileTypeC("GuidedMissile");
 
 
Index: trunk/src/world_entities/weapons/aiming_turret.h
===================================================================
--- trunk/src/world_entities/weapons/aiming_turret.h	(revision 9656)
+++ trunk/src/world_entities/weapons/aiming_turret.h	(revision 9869)
@@ -13,4 +13,6 @@
 class AimingTurret : public Weapon
 {
+  ObjectListDeclaration(AimingTurret);
+
 public:
   AimingTurret ();
Index: trunk/src/world_entities/weapons/ammo_container.cc
===================================================================
--- trunk/src/world_entities/weapons/ammo_container.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/ammo_container.cc	(revision 9869)
@@ -23,17 +23,17 @@
 
 
-
+ObjectListDefinition(AmmoContainer);
 /**
  * standard constructor
  * @todo this constructor is not jet implemented - do it
 */
-AmmoContainer::AmmoContainer (ClassID projectileType, float maxEnergy)
+AmmoContainer::AmmoContainer (const ClassID& projectileType, float maxEnergy)
 {
-   this->setClassID(CL_AMMO_CONTAINER, "AmmoContainer");
+  this->registerObject(this, AmmoContainer::_objectList);
 
-   this->projectileType = projectileType;
-   this->maxEnergy = maxEnergy;
+  this->projectileType = projectileType;
+  this->maxEnergy = maxEnergy;
 
-   this->energy = 0.0;
+  this->energy = 0.0;
 }
 
Index: trunk/src/world_entities/weapons/ammo_container.h
===================================================================
--- trunk/src/world_entities/weapons/ammo_container.h	(revision 9656)
+++ trunk/src/world_entities/weapons/ammo_container.h	(revision 9869)
@@ -17,10 +17,11 @@
 //! A class for Storing energy of Projectiles.
 class AmmoContainer : public BaseObject {
+  ObjectListDeclaration(AmmoContainer);
 
  public:
-  AmmoContainer(ClassID projectileType, float maxEnergy = DEFAULT_MAX_ENERGY);
+  AmmoContainer(const ClassID& id, float maxEnergy = DEFAULT_MAX_ENERGY);
   virtual ~AmmoContainer();
 
-  bool operator=(ClassID projectileType) const { return (this->projectileType == projectileType); };
+  bool operator=(int projectileType) const { return (this->projectileType == projectileType); };
   ClassID getProjectileType() const { return this->projectileType; };
 
Index: trunk/src/world_entities/weapons/boomerang_gun.cc
===================================================================
--- trunk/src/world_entities/weapons/boomerang_gun.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/boomerang_gun.cc	(revision 9869)
@@ -27,5 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(BoomerangGun, CL_BOOMERANG_GUN);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(BoomerangGun, CL_BOOMERANG_GUN);
+CREATE_FACTORY(BoomerangGun);
 
 
@@ -61,5 +63,5 @@
 void BoomerangGun::init()
 {
-  this->setClassID(CL_BOOMERANG_GUN, "BoomerangGun");
+  this->registerObject(this, BoomerangGun::_objectList);
 
 
@@ -85,5 +87,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_BOOMERANG_PROJECTILE);
+  this->setProjectileTypeC("BoomerangProjectile");
 
   this->loadModel("models/guns/turret1.obj", 5.0);
Index: trunk/src/world_entities/weapons/boomerang_gun.h
===================================================================
--- trunk/src/world_entities/weapons/boomerang_gun.h	(revision 9656)
+++ trunk/src/world_entities/weapons/boomerang_gun.h	(revision 9869)
@@ -11,4 +11,5 @@
 class BoomerangGun : public Weapon
   {
+    ObjectListDeclaration(BoomerangGun);
   public:
     BoomerangGun ();
Index: trunk/src/world_entities/weapons/cannon.cc
===================================================================
--- trunk/src/world_entities/weapons/cannon.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/cannon.cc	(revision 9869)
@@ -32,10 +32,11 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
-
-
-
-
-CREATE_FACTORY(Cannon, CL_CANNON);
+#include "loading/fast_factory.h"
+
+
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Cannon, CL_CANNON);
+CREATE_FACTORY(Cannon);
 
 /**
@@ -69,5 +70,5 @@
 void Cannon::init()
 {
-  this->setClassID(CL_CANNON, "Cannon");
+  this->registerObject(this, Cannon::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
@@ -88,5 +89,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_HEAVY);
-  this->setProjectileType(CL_BOMB);
+  this->setProjectileTypeC("Bomb");
   this->prepareProjectiles(5);
 
Index: trunk/src/world_entities/weapons/cannon.h
===================================================================
--- trunk/src/world_entities/weapons/cannon.h	(revision 9656)
+++ trunk/src/world_entities/weapons/cannon.h	(revision 9869)
@@ -12,4 +12,5 @@
 class Cannon : public Weapon
   {
+    ObjectListDeclaration(Cannon);
   public:
     Cannon ();
Index: trunk/src/world_entities/weapons/crosshair.cc
===================================================================
--- trunk/src/world_entities/weapons/crosshair.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/crosshair.cc	(revision 9869)
@@ -26,5 +26,5 @@
 
 
-
+ObjectListDefinition(Crosshair);
 /**
  * standart constructor
@@ -54,5 +54,5 @@
 void Crosshair::init()
 {
-  this->setClassID(CL_CROSSHAIR, "Crosshair");
+  this->registerObject(this, Crosshair::_objectList);
   this->setName("Crosshair");
 
Index: trunk/src/world_entities/weapons/crosshair.h
===================================================================
--- trunk/src/world_entities/weapons/crosshair.h	(revision 9656)
+++ trunk/src/world_entities/weapons/crosshair.h	(revision 9869)
@@ -22,5 +22,5 @@
 //! A class that enables the
 class Crosshair : public PNode, public Element2D, public EventListener {
-
+  ObjectListDeclaration(Crosshair);
  public:
   Crosshair(const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/weapons/fps_sniper_rifle.cc
===================================================================
--- trunk/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 9869)
@@ -29,5 +29,5 @@
 
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "fps_sniper_rifle.h"
@@ -39,5 +39,7 @@
 
 
-CREATE_FACTORY(FPSSniperRifle, CL_FPS_SNIPER_RIFLE);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(FPSSniperRifle, CL_FPS_SNIPER_RIFLE);
+CREATE_FACTORY(FPSSniperRifle);
 
 /**
@@ -76,5 +78,5 @@
 void FPSSniperRifle::init()
 {
-  this->setClassID(CL_FPS_SNIPER_RIFLE, "FPSSniperRifle");
+  this->registerObject(this, FPSSniperRifle::_objectList);
 
   this->loadModel("models/guns/fps_sniper_rifle.obj", 0.2);
@@ -98,5 +100,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_LASER);
+  this->setProjectileTypeC("Laser");
   this->prepareProjectiles(20);
 
@@ -181,5 +183,6 @@
 
   this->material->select();
-  static_cast<StaticModel*>(this->getModel())->draw();
+  this->getModel()->draw();
+  //static_cast<StaticModel*>(this->getModel())->draw();
 
   glPopMatrix();
Index: trunk/src/world_entities/weapons/fps_sniper_rifle.h
===================================================================
--- trunk/src/world_entities/weapons/fps_sniper_rifle.h	(revision 9656)
+++ trunk/src/world_entities/weapons/fps_sniper_rifle.h	(revision 9869)
@@ -39,4 +39,6 @@
 class FPSSniperRifle : public Weapon
   {
+    ObjectListDeclaration(FPSSniperRifle);
+
   public:
     FPSSniperRifle (int leftRight);
Index: trunk/src/world_entities/weapons/hyperblaster.cc
===================================================================
--- trunk/src/world_entities/weapons/hyperblaster.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/hyperblaster.cc	(revision 9869)
@@ -31,10 +31,11 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 
 
-
-CREATE_FACTORY(Hyperblaster, CL_HYPERBLASTER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Hyperblaster, CL_HYPERBLASTER);
+CREATE_FACTORY(Hyperblaster);
 
 Hyperblaster::Hyperblaster(const TiXmlElement* root)
@@ -56,5 +57,5 @@
 void Hyperblaster::init()
 {
-  this->setClassID(CL_HYPERBLASTER, "Hyperblaster");
+  this->registerObject(this, Hyperblaster::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
@@ -76,5 +77,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_HEAVY);
-  this->setProjectileType(CL_HYPERBLAST);
+  this->setProjectileTypeC("Hyperblast");
   this->prepareProjectiles(2);
 
Index: trunk/src/world_entities/weapons/hyperblaster.h
===================================================================
--- trunk/src/world_entities/weapons/hyperblaster.h	(revision 9656)
+++ trunk/src/world_entities/weapons/hyperblaster.h	(revision 9869)
@@ -12,5 +12,6 @@
 class Hyperblaster : public Weapon
   {
-  public:
+    ObjectListDeclaration(Hyperblaster);
+    public:
     Hyperblaster (const TiXmlElement* root = NULL);
     virtual ~Hyperblaster ();
Index: trunk/src/world_entities/weapons/laser_cannon.cc
===================================================================
--- trunk/src/world_entities/weapons/laser_cannon.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/laser_cannon.cc	(revision 9869)
@@ -29,8 +29,9 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
-CREATE_FACTORY(LaserCannon, CL_LASER_CANNON);
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(LaserCannon, CL_LASER_CANNON);
+CREATE_FACTORY(LaserCannon);
 
 LaserCannon::LaserCannon(const TiXmlElement* root)
@@ -52,5 +53,5 @@
 void LaserCannon::init()
 {
-  this->setClassID(CL_LASER_CANNON, "LaserCannon");
+  this->registerObject(this, LaserCannon::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/laser_cannon.obj", OBJ, RP_CAMPAIGN);
@@ -72,5 +73,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_RAIL_PROJECTILE);
+  this->setProjectileTypeC("RailProjectile");
   this->prepareProjectiles(100);
   this->setEmissionPoint(Vector(2.8,0,0) * 5.0);
Index: trunk/src/world_entities/weapons/laser_cannon.h
===================================================================
--- trunk/src/world_entities/weapons/laser_cannon.h	(revision 9656)
+++ trunk/src/world_entities/weapons/laser_cannon.h	(revision 9869)
@@ -29,5 +29,6 @@
 class LaserCannon : public Weapon
   {
-  public:
+    ObjectListDeclaration(LaserCannon);
+    public:
     LaserCannon (const TiXmlElement* root = NULL);
     virtual ~LaserCannon ();
Index: trunk/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/targeting_turret.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/targeting_turret.cc	(revision 9869)
@@ -26,9 +26,10 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(TargetingTurret, CL_TARGETING_TURRET);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(TargetingTurret, CL_TARGETING_TURRET);
+CREATE_FACTORY(TargetingTurret);
 
 
 TargetingTurret::TargetingTurret(const TiXmlElement* root)
-  : target(this)
 {
   this->init();
@@ -42,4 +43,6 @@
 TargetingTurret::~TargetingTurret ()
 {
+  if(Aim::objectList().exists(target))
+    delete target;
   // model will be deleted from WorldEntity-destructor
 //  delete this->target;
@@ -48,5 +51,6 @@
 void TargetingTurret::init()
 {
-  this->setClassID(CL_TARGETING_TURRET, "TargetingTurret");
+  this->registerObject(this, TargetingTurret::_objectList);
+  this->target = new Aim(this);
 
   Animation3D* animation1 = this->getAnimation(WS_ACTIVATING, this);
@@ -70,5 +74,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_GUIDED_MISSILE);
+  this->setProjectileTypeC("GuidedMissile");
 
 
@@ -76,9 +80,9 @@
   //this->getProjectileFactory()->prepare(100);
 
-  this->target.setVisibility(false);
-  this->target.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT | PNODE_PROHIBIT_CHILD_DELETE);
-  this->target.setRange(1000);
-  this->target.setAngle(M_PI_4);
-  this->lockedTarget = &this->target;
+  this->target->setVisibility(false);
+  this->target->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT | PNODE_PROHIBIT_CHILD_DELETE);
+  this->target->setRange(1000);
+  this->target->setAngle(M_PI_4);
+  this->lockedTarget = this->target;
 
   this->lockedTime = 0;
@@ -97,5 +101,5 @@
   Weapon::loadParams(root);
 
-  LoadParam(root, "target-group", &target, Aim, setTargetGroupS);
+  LoadParam(root, "target-group", target, Aim, setTargetGroupS);
 
 }
@@ -109,5 +113,5 @@
 void TargetingTurret::deactivate()
 {
-  this->target.setVisibility(false);
+  this->target->setVisibility(false);
 }
 
@@ -117,14 +121,14 @@
     return;
 
-  this->target.tick(dt);
+  this->target->tick(dt);
 
   if( lockedTime >= neededLockTime )
    {
-    lockedTarget = this->target.getParent();
+    lockedTarget = this->target->getParent();
     lockedTime = 0;
    }
 
 
-  if(this->target.getParent() == PNode::getNullParent())
+  if(this->target->getParent() == PNode::getNullParent())
    lockedTime = 0;
   else
Index: trunk/src/world_entities/weapons/targeting_turret.h
===================================================================
--- trunk/src/world_entities/weapons/targeting_turret.h	(revision 9656)
+++ trunk/src/world_entities/weapons/targeting_turret.h	(revision 9869)
@@ -12,4 +12,5 @@
 class TargetingTurret : public Weapon
 {
+  ObjectListDeclaration(TargetingTurret);
 public:
   TargetingTurret(const TiXmlElement* root = NULL);
@@ -26,5 +27,5 @@
   virtual void draw() const;
 
-  void setTargetGroup(OM_LIST targetGroup) { this->target.setTargetGroup(targetGroup); };
+  void setTargetGroup(OM_LIST targetGroup) { this->target->setTargetGroup(targetGroup); };
   const PNode* getLockedTarget() const { return lockedTarget; };
 
@@ -33,5 +34,5 @@
 
 private:
-  Aim            target;
+  Aim*           target;
   PNode*         lockedTarget;
   float          lockedTime;
Index: trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- trunk/src/world_entities/weapons/test_gun.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/test_gun.cc	(revision 9869)
@@ -31,8 +31,9 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
-
-CREATE_FACTORY(TestGun, CL_TEST_GUN);
-
+#include "loading/fast_factory.h"
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(TestGun, CL_TEST_GUN);
+CREATE_FACTORY(TestGun);
 /**
  *  standard constructor
@@ -109,6 +110,5 @@
 void TestGun::init()
 {
-  this->setClassID(CL_TEST_GUN, "TestGun");
-
+  this->registerObject(this, TestGun::_objectList);
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
 
@@ -129,5 +129,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_LASER);
+  this->setProjectileTypeC("Laser");
   this->prepareProjectiles(100);
 
Index: trunk/src/world_entities/weapons/test_gun.h
===================================================================
--- trunk/src/world_entities/weapons/test_gun.h	(revision 9656)
+++ trunk/src/world_entities/weapons/test_gun.h	(revision 9869)
@@ -37,4 +37,5 @@
 class TestGun : public Weapon
   {
+    ObjectListDeclaration(TestGun);
   public:
     TestGun (int leftRight);
Index: trunk/src/world_entities/weapons/turret.cc
===================================================================
--- trunk/src/world_entities/weapons/turret.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/turret.cc	(revision 9869)
@@ -27,7 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(Turret, CL_TURRET);
-
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Turret, CL_TURRET);
+CREATE_FACTORY(Turret);
 
 /**
@@ -62,5 +62,5 @@
 void Turret::init()
 {
-  this->setClassID(CL_TURRET, "Turret");
+  this->registerObject(this, Turret::_objectList);
 
 
@@ -86,5 +86,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_ROCKET);
+  this->setProjectileTypeC("Rocket");
 
   this->loadModel("models/guns/turret1.obj");
Index: trunk/src/world_entities/weapons/turret.h
===================================================================
--- trunk/src/world_entities/weapons/turret.h	(revision 9656)
+++ trunk/src/world_entities/weapons/turret.h	(revision 9869)
@@ -11,4 +11,5 @@
 class Turret : public Weapon
   {
+    ObjectListDeclaration(Turret);
   public:
     Turret ();
